SystemOrganization addCategory: #'Seaside-Adaptors-Comanche'!

WAObject subclass: #WAKom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Adaptors-Comanche'!

WAKom class
	instanceVariableNames: 'default'!

!WAKom commentStamp: 'jf 1/4/2009 22:36' prior: 0!
Compatibility class to maintain WAKom interface from Seaside 2.8 and older.!

WAKom class
	instanceVariableNames: 'default'!

!WAKom class methodsFor: 'private' stamp: 'jf 3/17/2009 14:49'!
adaptorClass
	^ WAComancheAdaptor! !

!WAKom class methodsFor: 'compatibility' stamp: 'jf 3/17/2009 15:23'!
default
	^ (default notNil and: [ default manager notNil ])
		ifTrue: [ default ]
		ifFalse: [ nil ]! !

!WAKom class methodsFor: 'private' stamp: 'jf 9/30/2009 00:27'!
defaultCodec
	^ GRNullCodec new! !

!WAKom class methodsFor: 'compatibility' stamp: 'jf 3/17/2009 15:25'!
port
	^ self default isNil ifFalse: [ self default port ]! !

!WAKom class methodsFor: 'compatibility' stamp: 'jf 3/17/2009 15:27'!
start
	^ self default isNil
		ifFalse: [ self default start; yourself ]
		ifTrue: [ self error: 'No adaptor currently configured. Use #startOn:.'. nil ]! !

!WAKom class methodsFor: 'compatibility' stamp: 'jf 3/17/2009 15:24'!
startOn: portInteger
	self default isNil
		ifFalse: [ self default stop; port: portInteger ]
		ifTrue: [
			default := self adaptorClass port: portInteger.
			default codec: self defaultCodec ].
	^ self start! !

!WAKom class methodsFor: 'compatibility' stamp: 'jf 3/17/2009 15:27'!
stop
	self default isNil ifFalse: [ self default stop ]! !

WAKom subclass: #WAKomEncoded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Adaptors-Comanche'!

!WAKomEncoded commentStamp: 'jf 3/17/2009 13:46' prior: 0!
Compatibility class to maintain WAKomEncoded interface from Seaside 2.8 and older.

Creates an instance of WAComancheAdaptor configured to convert requests/responses from/to UTF-8 to/from Squeak's native internal encoding.!

!WAKomEncoded class methodsFor: 'private' stamp: 'jf 9/30/2009 00:46'!
defaultCodec
	^ GRPharoUtf8Codec new! !

WAKomEncoded subclass: #WAKomEncoded39
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Adaptors-Comanche'!

!WAKomEncoded39 commentStamp: 'jf 1/4/2009 22:39' prior: 0!
I have exactly the same resposibility as WAKomEncoded and am only provided for compatility reasons with old versions. I should not be used anymore.!

!SocketStream methodsFor: '*seaside-adaptors-comanche' stamp: 'lr 2/7/2009 16:09'!
basicNextPut: anObject
	^ self nextPut: anObject! !

!SocketStream methodsFor: '*seaside-adaptors-comanche' stamp: 'lr 2/7/2009 16:02'!
size
	"This is just a guess, probably more was written."

	^ outNextToWrite! !

!GRPackage class methodsFor: '*seaside-adaptors-comanche' stamp: 'lr 2/17/2010 15:12'!
seasideAdaptorsComanche
	^ self new
		name: 'Seaside-Adaptors-Comanche';
		description: 'Makes Seaside run on the Comanche HTTP server.';
		addDependency: 'Seaside-Pharo-Core';
		url: #seasideUrl;
		yourself! !

GRCodecStream subclass: #GRSwitchableStream
	instanceVariableNames: 'codecStream socketStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Adaptors-Comanche'!

!GRSwitchableStream commentStamp: 'pmm 4/10/2010 13:25' prior: 0!
A GRSwitchableStream is a class that implements the same protocol as and in addition allows switching between text and binary mode.

Instance Variables
	codecStream:		<GRCodecStream>
	socketStream:		<SocketStream>

codecStream
	- we codec stream, that does encoding

socketStream
	- we socket stream, that does no encoding

stream
	- the current stream to be used
!

!GRSwitchableStream class methodsFor: 'instance-creation' stamp: 'pmm 4/10/2010 13:18'!
onCodecStream: aCodecStream socketStream: aSocketStream
	^ self basicNew onCodecStream: aCodecStream socketStream: aSocketStream! !

!GRSwitchableStream methodsFor: 'accessing' stamp: 'pmm 4/11/2010 22:10'!
binary
 	"Put the receiver into binary mode, makes it byte based"
	stream := socketStream.
	socketStream binary! !

!GRSwitchableStream methodsFor: 'streaming' stamp: 'pmm 4/10/2010 13:22'!
crlf
	stream crlf! !

!GRSwitchableStream methodsFor: 'streaming' stamp: 'pmm 4/10/2010 13:23'!
next
	^ stream next! !

!GRSwitchableStream methodsFor: 'streaming' stamp: 'pmm 4/10/2010 13:23'!
next: anInteger
	^ stream next: anInteger! !

!GRSwitchableStream methodsFor: 'streaming' stamp: 'pmm 4/10/2010 13:23'!
nextPut: aCharacter
	^ stream nextPut: aCharacter! !

!GRSwitchableStream methodsFor: 'streaming' stamp: 'pmm 4/10/2010 13:23'!
nextPutAll: aString
	^ stream nextPutAll: aString! !

!GRSwitchableStream methodsFor: 'initialization' stamp: 'pmm 4/11/2010 10:25'!
onCodecStream: aCodecStream socketStream: aSocketStream
	self initalizeOn: aCodecStream.
	codecStream := aCodecStream.
	socketStream := aSocketStream! !

!GRSwitchableStream methodsFor: 'streaming' stamp: 'pmm 4/10/2010 13:23'!
space
	^ stream space! !

!GRSwitchableStream methodsFor: 'accessing' stamp: 'pmm 4/11/2010 22:11'!
text
 	"Put the receiver into text mode, makes it character based"
	stream := codecStream.
	socketStream text! !

WAServerAdaptor subclass: #WAComancheRequestConverter
	instanceVariableNames: 'streamUploads'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Adaptors-Comanche'!

!WAComancheRequestConverter commentStamp: 'jf 1/4/2009 22:38' prior: 0!
I am the common superclass for all classes that provided connectivity with the Comanche web server (Kom). Among other thing I do encoding and decoding of requests and responses. I have two main subclasses, WAComancheAdaptor is a traditional server adapter whereas WAListener is a streaming server adapter that proves Comet functioanlity. When in doubt, pick WAComancheAdaptor.

The encoding can be configured with the #endocing: method. The following values are allowed arguments:
nil
	switches off all encoding
	Strings will be delivered to you in the encoding the client used as ByteStrings. You can configure the encoding of these strings with the #charSet setting of your application. All Strings you return must have this encoding as well.
	
'utf-8'
	uses the utf-8 fast path by Andreas Raab
	Strings will be delivered to you as Squeak encoded Strings (minus the leading char). All the Strings you return must as well be Squeak encoded. Responses send to the client will be utf-8 encoded. You must additionally set the #charSet setting of your application to 'utf-8' (should be the default).
	
any other encoding supported by Squeak, see TextConverter allEncodingNames
	uses whatever TextConverter Squeak uses for this encoding
	Strings will be delivered to you as Squeak encoded Strings (minus the leading character). All the Strings you return must as well be Squeak encoded. Responses send to the client will be in the specified encoding. You must additionally set the #charSet setting of your application to the desired value.!

WAComancheRequestConverter subclass: #WAComancheAdaptor
	instanceVariableNames: 'service'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Adaptors-Comanche'!

!WAComancheAdaptor commentStamp: 'jf 1/4/2009 22:38' prior: 0!
I provide an adapter between Seaside and the Comanche web server. To start a new server on port 8080, evaluate

	WAComancheAdaptor startOn: 8080.
	
and to stop it, evaluate

	WAComancheAdaptor stop.

By default I don't do any input conversion at all, you will get the input in whatever encoding the client sent and are expected to deliver it in the same. Howerver this behavior can be changed by evaluating
WAComancheAdaptor default encoding: anEncoding
See the class comment of the superclass for a discussion on this topic.!

!WAComancheAdaptor methodsFor: 'private' stamp: 'jf 10/30/2008 13:28'!
basicStart
	service := self createService.
	service start! !

!WAComancheAdaptor methodsFor: 'private' stamp: 'lr 8/31/2009 17:00'!
basicStop
	service isNil
		ifFalse: [ service unregister; waitForStop ].
	service := nil! !

!WAComancheAdaptor methodsFor: 'private' stamp: 'lr 2/16/2009 20:56'!
convertCookiesFrom: aWAResponse to: aKomResponse
	| cookies |
	cookies := aWAResponse cookies.
	cookies isEmpty ifTrue: [ ^self ].

	cookies do: [ :each |
		"user Seaside serialization for full features instead of Kom
		this is quite evil code that works only because it knows the exact implemation of this method in Kom"
		aKomResponse
			setCookieName: each key
			value: each oldNetscapeStringWithoutKey
			path: nil ].
		
	aKomResponse
		fieldAt: 'Set-Cookie2'
		put: (WACookie combine: cookies using: [ :each | each rfc2965String ])! !

!WAComancheAdaptor methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
createService
	^ (HttpService on: self port)
		name: 'seaside-' , self port greaseString;
		plug: self;
		yourself! !

!WAComancheAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:38'!
isRunning
	^ service notNil and: [ service isRunning ]! !

!WAComancheAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:50'!
isStarting
	^ service notNil and: [ service isStopped ]! !

!WAComancheAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:42'!
isStopped
	^ service isNil! !

!WAComancheAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:44'!
isStopping
	^ service notNil and: [ service isStopping ]! !

!WAComancheAdaptor methodsFor: 'adapting' stamp: 'ab 5/18/2003 13:53'!
processHttp
	HttpResponse current: (self process: HttpRequest current).
	^ true! !

!WAComancheAdaptor methodsFor: 'adapting' stamp: 'ab 5/18/2003 11:24'!
processHttpRequest: aRequest
	^ self process: aRequest! !

!WAComancheAdaptor methodsFor: 'converting' stamp: 'jf 9/30/2009 01:10'!
responseFrom: aRequestContext 
	| response |
	response := HttpResponse new.
	aRequestContext response headers keysAndValuesDo: 
		[ :key :value | 
		key = 'Content-Type' 
			ifTrue: [ response contentType: value greaseString ]
			ifFalse: 
				[ response 
					fieldAt: key
					put: value greaseString ] ].
	self 
		convertCookiesFrom: aRequestContext response
		to: response.
	response status: (HttpResponse statusSymbolFor: aRequestContext response status).
	response contents: aRequestContext response stream contents readStream.
	^ response! !

!WAComancheAdaptor methodsFor: 'mode' stamp: 'jf 10/29/2008 16:51'!
setDebugMode
	service setDebugMode! !

!WAComancheAdaptor methodsFor: 'mode' stamp: 'jf 10/29/2008 16:51'!
setDeploymentMode
	service setDeploymentMode! !

!WAComancheAdaptor methodsFor: 'mode' stamp: 'jf 10/29/2008 16:52'!
setVerboseMode
	service setVerboseMode! !

!WAComancheAdaptor methodsFor: 'private' stamp: 'lr 2/28/2009 22:46'!
shutDown
	service isNil
		ifFalse: [ service stop ]! !

!WAComancheAdaptor methodsFor: 'private' stamp: 'lr 2/28/2009 22:46'!
startUp
	service isNil
		ifFalse: [ service start ]! !

!WAComancheAdaptor methodsFor: 'accessing-readonly' stamp: 'jf 9/30/2009 01:10'!
statusString
	^ self isRunning 
		ifTrue: [ service greaseString ]
		ifFalse: [ super statusString ]! !

!WAComancheAdaptor methodsFor: 'adapting' stamp: 'ab 5/18/2003 14:11'!
validateForStack: anArray! !

!WAComancheRequestConverter class methodsFor: 'testing' stamp: 'jf 1/4/2009 22:16'!
isAbstract
	^ self name = #WAComancheRequestConverter! !

!WAComancheRequestConverter methodsFor: 'private' stamp: 'lr 2/7/2009 11:59'!
convertMultipartFileField: aChunk
	^(self fileClass fromChunk: aChunk)
		fileName: (self codec url decode: aChunk fileName);
		yourself! !

!WAComancheRequestConverter methodsFor: 'private' stamp: 'jf 2/15/2010 19:42'!
decodeFields: aDictionary using: aOneArgumentBlock into: aRequestFields
	aDictionary keysAndValuesDo: [ :key :value |
		value isString
			ifTrue: [ aRequestFields at: key add: (aOneArgumentBlock value: value) ]
			ifFalse: [
				(value isCollection)
					ifTrue: [ value do: [ :string |
						aRequestFields at: key add: (aOneArgumentBlock value: string) ] ]
					ifFalse: [ aRequestFields at: key add: value ] ] ]! !

!WAComancheRequestConverter methodsFor: 'private' stamp: 'pmm 4/18/2008 06:54'!
fileClass
	^streamUploads
		ifTrue: [ WATemporaryFile ]
		ifFalse: [ WAFile ]! !

!WAComancheRequestConverter methodsFor: 'initialization' stamp: 'jf 10/29/2008 18:40'!
initialize
	super initialize.
	streamUploads := false! !

!WAComancheRequestConverter methodsFor: 'private' stamp: 'lr 2/7/2009 12:00'!
isUrlEncoded: aNativeRequest
	"answers whether the body of the given request is url encoded"
	^aNativeRequest contentType = 'application/x-www-form-urlencoded'! !

!WAComancheRequestConverter methodsFor: 'private' stamp: 'jf 2/15/2010 18:01'!
postFieldsOf: aNativeRequest into: aRequestFields
	"puts all the POST parameters of the given request decoded into a WARequestFields"
	| isUrlEncoded |
	isUrlEncoded := self isUrlEncoded: aNativeRequest.
	^self
		decodeFields: aNativeRequest postFields
		using: [ :each |
			isUrlEncoded 
				ifTrue: [ self codec url decode: each ]
				ifFalse: [ self codec decode: each ] ]
		into: aRequestFields! !

!WAComancheRequestConverter methodsFor: 'private' stamp: 'jf 2/15/2010 18:03'!
processMultipartFields: aKomRequest
	| fields |
	fields := WARequestFields new.	

	aKomRequest multipartFormFieldsDo: [ :chunk |
		| key value |
		key := chunk fieldName.
		value := chunk fileName isEmptyOrNil
			ifTrue: [
				String streamContents: [ :stream |
					chunk saveToStream: stream ] ]
			ifFalse: [ self convertMultipartFileField: chunk ].
		fields at: key add: value ].
	
	"ugly"
	aKomRequest propertyAt: #postFields put: fields! !

!WAComancheRequestConverter methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:37'!
requestAddressFor: aNativeRequest
	| remoteAddress |
	remoteAddress := aNativeRequest remoteAddress.
	remoteAddress isString
		ifTrue: [ ^ remoteAddress ].
	^ String streamContents: [ :stream |
		remoteAddress
			do: [ :each | stream print: each ]
			separatedBy: [ stream nextPut: $. ] ]! !

!WAComancheRequestConverter methodsFor: 'converting-request' stamp: 'pmm 6/30/2010 22:05'!
requestBodyFor: aNativeRequest
	
	^ aNativeRequest method = 'PUT'
		ifTrue: [
			"bloody, unholy hack"
			aNativeRequest stream next: aNativeRequest contentLength ]
		ifFalse: [
			"This will only work for POST requests... not really cool."
			aNativeRequest rawPostFields ]! !

!WAComancheRequestConverter methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:38'!
requestCookiesFor: aNativeRequest
	^ WARequestCookie fromString: (aNativeRequest header at: 'cookie' ifAbsent: [ nil ])! !

!WAComancheRequestConverter methodsFor: 'converting-request' stamp: 'jf 2/15/2010 18:02'!
requestFieldsFor: aNativeRequest
	| fields |
	fields := WARequestFields new.
	aNativeRequest isPostRequest
		ifTrue: [ self postFieldsOf: aNativeRequest into: fields ].
	^ fields! !

!WAComancheRequestConverter methodsFor: 'converting' stamp: 'lr 2/16/2009 20:39'!
requestFor: aNativeRequest
	aNativeRequest multiValueFormFieldsEnable.
	aNativeRequest isPostMultipart 
		ifTrue: [ self processMultipartFields: aNativeRequest ].
	^ super requestFor: aNativeRequest! !

!WAComancheRequestConverter methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:39'!
requestHeadersFor: aNativeRequest
	^ aNativeRequest header! !

!WAComancheRequestConverter methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:40'!
requestMethodFor: aNativeRequest
	^ aNativeRequest method! !

!WAComancheRequestConverter methodsFor: 'converting-request' stamp: 'jf 1/30/2010 23:47'!
requestUrlFor: aNativeRequest
	^ (WAUrl absolute: aNativeRequest rawUrl)
		decodedWith: self codec! !

!WAComancheRequestConverter methodsFor: 'converting-request' stamp: 'jf 7/31/2009 12:36'!
requestVersionFor: aNativeRequest
	^ WAHttpVersion fromString: aNativeRequest protocol! !

!WAComancheRequestConverter methodsFor: 'accessing' stamp: 'lr 2/15/2009 17:47'!
streamUploads: aBoolean
	"Enables or disables upload streaming. If set to true, then all file uploads will be written to a temparory file."

	streamUploads := aBoolean
	! !

WAComancheRequestConverter subclass: #WAListenerAdaptor
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Adaptors-Comanche'!

!WAListenerAdaptor commentStamp: 'jf 1/4/2009 22:39' prior: 0!
I am a streaming server that directly writes the resulting data onto the socket. I use the request parsing of Comanche, otherwise I am a web server on my own.

Note that the WAListener is not supposed to support redirects during the rendering phase, like it is done in WABasicAuthentication. It might work in the case the buffers of the socket stream haven't been flushed yet, but in most cases it doesn't. This is not a bug and will never be changed.!

!WAListenerAdaptor methodsFor: 'private' stamp: 'lr 2/7/2009 15:22'!
basicStart
	process := [ [ self listenLoop ] repeat ] newProcess.
	process priority: Processor userBackgroundPriority.
	process name: 'seaside-' , self port printString.
	process resume! !

!WAListenerAdaptor methodsFor: 'private' stamp: 'lr 2/28/2009 22:41'!
basicStop
	process isNil
		ifFalse: [ process terminate ].
	process := nil! !

!WAListenerAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:54'!
isRunning
	^ process notNil and: [ process isTerminated not ]! !

!WAListenerAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:59'!
isStarting
	^ process notNil and: [ process isSuspended ]! !

!WAListenerAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:51'!
isStopped
	^ process isNil! !

!WAListenerAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:53'!
isStopping
	^ process notNil and: [ process isTerminated ]! !

!WAListenerAdaptor methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
listenLoop
	| socket |
	socket := Socket newTCP.
	socket 
		listenOn: port
		backlogSize: 50.
	socket isValid ifFalse: [ self error: 'Cannot listen on port ' , port greaseString ].
	
	[ 
	[ socket isValid ifFalse: [ ^ self listenLoop ].
	self waitForConnection: socket ] repeat ] ifCurtailed: 
		[ (Delay forMilliseconds: 10) wait.
		socket destroy ]! !

!WAListenerAdaptor methodsFor: 'converting' stamp: 'lr 2/7/2009 15:04'!
requestFor: aSocketStream
	^ super requestFor: (HttpRequest readFromStream: aSocketStream)! !

!WAListenerAdaptor methodsFor: 'converting' stamp: 'pmm 4/10/2010 13:20'!
responseFor: aSocketStream
	^ WAStreamedResponse
		on: (GRSwitchableStream
			onCodecStream: (self codec encoderFor: aSocketStream)
			socketStream: aSocketStream)! !

!WAListenerAdaptor methodsFor: 'converting' stamp: 'lr 2/16/2009 20:47'!
responseFrom: aRequestContext
	aRequestContext response flush! !

!WAListenerAdaptor methodsFor: 'private' stamp: 'lr 2/28/2009 22:40'!
shutDown
	process isNil
		ifFalse: [ process terminate ]! !

!WAListenerAdaptor methodsFor: 'private' stamp: 'lr 2/28/2009 22:41'!
startUp
	process isNil
		ifFalse: [ self restart ]! !

!WAListenerAdaptor methodsFor: 'private' stamp: 'lr 2/7/2009 15:58'!
waitForConnection: aSocket
	| socket stream |
	socket := aSocket waitForAcceptFor: 10.
	socket isNil ifTrue: [ ^ self ].
	stream := SocketStream on: socket.
	[ [ [ self process: stream ]
		ensure: [ stream close ] ]
			ifCurtailed: [ socket destroy ] ]
				forkAt: Processor userBackgroundPriority! !

!WAFile class methodsFor: '*seaside-adaptors-comanche' stamp: 'jf 2/15/2010 20:39'!
fromChunk: aChunk
	^ self new readFromChunk: aChunk; yourself! !

!WAFile methodsFor: '*seaside-adaptors-comanche' stamp: 'pmm 4/17/2008 20:46'!
isTemporary
	"this is not a temporary but an in memory file"
	^false! !

!WAFile methodsFor: '*seaside-adaptors-comanche' stamp: 'jf 2/15/2010 20:38'!
readFromChunk: aChunk
	self contentType: aChunk contentType seasideMimeType.
	self contents: (String streamContents: [ :stream |
		aChunk saveToStream: stream ]) asByteArray.! !

WAFile subclass: #WATemporaryFile
	instanceVariableNames: 'temporaryFileName fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Adaptors-Comanche'!

!WATemporaryFile commentStamp: 'pmm 4/18/2008 22:52' prior: 0!
I represent a file that was uploaded by the user via #fileInput. Compared to WAFile my contents are not stored in memory on disk in a temporary file. I support the same protocol as WAFile.

Instance Variables
	fileSize:		<Integer>
	temporaryFileName:		<String>

fileSize
	- the file size in bytes

temporaryFileName
	- the name of the file in which my contents are stored on disk!

!WATemporaryFile methodsFor: 'actions' stamp: 'pmm 8/1/2008 14:10'!
delete
	"deletes the uploaded file from the disk"
	self temporaryDirectory deleteFileNamed: self temporaryFileName! !

!WATemporaryFile methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:09'!
initializeFromChunk: aChunk
	"This is where we actually read the file contents chunk wise
	and save it to disk."

	| stream |
	self initialize.
	stream := StandardFileStream newFileNamed: (self temporaryDirectory fullNameFor: self temporaryFileName).
	fileSize := [ stream binary.
		aChunk saveToStream: stream ]
			ensure: [ stream close ]! !

!WATemporaryFile methodsFor: 'testing' stamp: 'pmm 4/17/2008 20:46'!
isTemporary
	"this is not an in memory but an in temporary file"
	^true! !

!WATemporaryFile methodsFor: 'accessing' stamp: 'pmm 11/14/2009 14:24'!
rawContents
	"Reads the contents of the file into memory and returns them.
	Keep in mind that the contents will be cached into an instance variable."
	contents isNil ifTrue: [
		contents := self readStreamDo: [ :stream |
			stream contents ] ].
	^contents! !

!WATemporaryFile methodsFor: 'actions' stamp: 'pmm 8/1/2008 14:15'!
readStreamDo: aOneArgumentBlock
	"Convenience method to access a read stream on the contents. The read stream will be passed to the block.
	the stream will be in binary mode
	the stream will be closed afterwards"
	| stream |
	stream := self temporaryDirectory readOnlyFileNamed: self temporaryFileName.
	^[	stream binary.
		aOneArgumentBlock value: stream ]
			ensure: [ stream close ]! !

!WATemporaryFile methodsFor: 'accessing' stamp: 'pmm 4/18/2008 22:46'!
size
	"the file size in bytes"
	^fileSize! !

!WATemporaryFile methodsFor: 'accessing' stamp: 'pmm 4/18/2008 22:50'!
temporaryDirectory
	"the directory in which the file is located in which my contents are stored on the server"
	^(FileDirectory default directoryNamed: 'seasidetmp') assureExistence! !

!WATemporaryFile methodsFor: 'accessing' stamp: 'lr 1/10/2009 12:50'!
temporaryFileName
	"the name of the file in which my contents are stored in the directory #temporaryDirectory
	
	don't confuse this with #fileName which is the name of the file that the client sent"
	^ temporaryFileName ifNil: [ temporaryFileName := WAKeyGenerator current keyOfLength: 48 ]! !
